"use strict";
const util_1 = require("./util");
module.exports = function initHtmlPlugin(modules) {
    const ts = modules.typescript;
    return {
        create(info) {
            const proxy = (0, util_1.proxyObject)(info.languageService);
            proxy.getSemanticDiagnostics = function clonedSemanticDiagnostics(filename) {
                const diagnostics = info.languageService.getSemanticDiagnostics(filename);
                // Not a tsx file, so don't do anything
                if (!filename.endsWith('.tsx') && !filename.endsWith('.jsx')) {
                    return diagnostics;
                }
                const program = info.languageService.getProgram();
                if (!program) {
                    return diagnostics;
                }
                const source = program.getSourceFile(filename);
                if (!source) {
                    return diagnostics;
                }
                const typeChecker = program.getTypeChecker();
                ts.forEachChild(source, function loopSourceNodes(node) {
                    (0, util_1.recursiveDiagnoseJsxElements)(ts, node, typeChecker, diagnostics);
                });
                return diagnostics;
            };
            return proxy;
        }
    };
};
//# sourceMappingURL=index.js.map